
package de.ivu.elect.business.kandidatur.control;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.control.GewaehltCreate;
import de.ivu.elect.business.ergebnis.entity.Gewaehlt;
import de.ivu.elect.business.kandidatur.boundary.KandidaturDAO;
import de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur;
import de.ivu.elect.business.kandidatur.entity.Kandidatur;
import de.ivu.elect.business.personenpruefung.boundary.PersonenPruefungStarter;
import de.ivu.elect.business.staat.boundary.StaatDAO;
import de.ivu.elect.business.staat.entity.Staat;
import de.ivu.elect.business.wahl.boundary.WahlDAO;
import de.ivu.elect.business.wahl.entity.Wahl;

public class ErsatzkandidaturCreate extends AbstractErsatzkandidaturCreate {

  @Inject
  protected WahlDAO wahlDao;

  @Inject
  protected StaatDAO staatDao;

  @Inject
  protected KandidaturDAO kandidaturDao;

  @Inject
  protected GewaehltCreate gewaehltCreate;

  @Inject
  protected PersonenPruefungStarter personenPruefungStarter;

  public ErsatzkandidaturCreate() {
    super();
  }

  @Override
  public void save(Ersatzkandidatur ersatzkandidatur) {
    save(ersatzkandidatur.getWahl(), ersatzkandidatur.getUebergeordneteKandidatur(), ersatzkandidatur.getGewaehlte(), ersatzkandidatur,
        new ArrayList<>(ersatzkandidatur.getStaatsangehoerigkeitenSorted()));
  }

  public void save(Wahl wahl, Kandidatur uebergeordneteKandidatur, List<Gewaehlt> gewaehlte, Ersatzkandidatur ersatzkandidatur,
      List<Staat> staatsangehoerigkeitenSorted) {
    ersatzkandidatur.setWahl(attach(wahl));
    ersatzkandidatur.setUebergeordneteKandidatur(attach(uebergeordneteKandidatur));
    ersatzkandidatur.setStaatsangehoerigkeitenSorted(attachAll(staatsangehoerigkeitenSorted));

    super.save(ersatzkandidatur);

    save(gewaehlte);

    personenPruefungStarter.startePersonenPruefung();
  }

  private void save(List<Gewaehlt> gewaehlte) {
    for (Gewaehlt gewaehlt : gewaehlte) {
      gewaehltCreate.save(gewaehlt);
    }
  }

  private Kandidatur attach(Kandidatur kandidatur) {
    return kandidaturDao.attach(kandidatur);
  }

  private Wahl attach(Wahl wahl) {
    return wahlDao.attach(wahl);
  }

  private List<Staat> attachAll(List<Staat> staatsangehoerigkeiten) {
    return staatsangehoerigkeiten.stream().map(staatsangehoerigkeit -> staatDao.attach(staatsangehoerigkeit)).collect(Collectors.toList());
  }
}
